unit BaseLib;

interface

uses Windows, KOL;

{$A-}
{$DEFINE PCode} //         !

procedure PExit;
procedure PReturn;
procedure PResult;
procedure ResultB;

procedure Del;
procedure DelN;
procedure Dup;
procedure xCopy;
procedure C1;
procedure C2;
procedure C3;
procedure C4;
procedure C5;
procedure C6;

procedure C2R;
procedure R2C;
procedure R2CN;
procedure CswapR;

procedure xySwap;
procedure xSwpN;
procedure xSwp1;
procedure xSwp2;
procedure xSwp3;
procedure xSwp4;
procedure xSwp5;
procedure xSwp6;
procedure xyAdd;
procedure xySub;
procedure xyMul;
procedure xyMulMul;
procedure xyIntDiv;
procedure xyDivMod;
procedure xNeg;
procedure xyShiftL;
procedure xyShiftR;
procedure xyAnd;
procedure xyOr;
procedure xyXor;
procedure xyNot;
procedure xLE0;

procedure StoreB;
procedure StoreW;
procedure Store;
procedure StoreQ;
procedure StoreVar;

procedure LoadStack;
procedure LoadByte;
procedure LoadSignedByte;
procedure LoadWord;
procedure LoadSmallInt;
procedure Load3;
procedure Load4;
procedure Load8;
procedure LoadVar;
procedure Load_Applet;
procedure Load_hInstance;

procedure LoadStr;
procedure LoadAnsiStr;
procedure DelAnsiStr;

procedure LoadPCharArray;

procedure SetSELF;
procedure LoadSELF;
procedure SelfOffsetW;
procedure SelfOffsetB;

procedure LoadHInstance;

procedure LoadRef;
procedure LoadRefByte;
procedure LoadRefWord;
procedure AddByte_LoadRef;
procedure AddWord_LoadRef;
procedure AddByte_Store;
procedure AddByte_StoreB;
procedure AddWord_Store;
procedure AddWord_StoreB;
procedure ParamByte;
procedure ParamWord;
procedure Param3;
procedure Param4;

procedure PASCAL1;
procedure PASCAL2;
procedure PASCAL3;

procedure Debug;

implementation

uses Collapse;

procedure PExit;
asm
  SUB EDI, 8
  MOV EBP, [EDI+4]
  MOV ESI, [EDI]
  TEST ESI, ESI
  JZ @@EXIT_asmCode
  RET
@@EXIT_asmCode:
  XCHG EAX, EDI
  SUB EAX, 12
  MOV EBX, [EAX+8]
  MOV ESI, [EAX+4]
  MOV EDI, [EAX]
  //PUSH EAX
  //CALL GlobalFree
  CALL System.@FreeMem
  POP EAX //      -
end;

procedure PReturn;
asm
  SUB EDI, 8
  MOV EBP, [EDI+4]
  MOV ESI, [EDI]
  TEST ESI, ESI
  JZ @@RETURN_asmCode
  MOV EBX, [ESP+4] //   -    EBX
  RET 4
@@RETURN_asmCode:
  XCHG EAX, EDI
  SUB EAX, 12
  MOV EBX, [EAX+8]
  MOV ESI, [EAX+4]
  MOV EDI, [EAX]
  //PUSH EAX
  //CALL GlobalFree
  CALL System.@FreeMem
  POP EAX //      -
  POP EAX //       EAX  ,     .
end;

procedure PResult;
asm
  POP EAX
  PUSH EBX
  JMP EAX
end;

procedure ResultB;
asm
  POP EAX
  MOVZX EBX, BL
  PUSH EBX
  JMP EAX
end;

procedure Del;
asm
  xchg ebx, eax
  pop  ecx
  pop  edx
  jmp  ecx
end;

procedure DelN;
asm
  pop  edx
  pop  ecx
  lea  esp, [esp+ecx*4]
  jmp  edx
end;

procedure Dup;
asm
  pop  edx
  push dword ptr[esp]
  jmp  edx
end;

procedure xCopy;
asm
  pop  edx
  pop  eax
  push dword ptr [esp+eax*4]
  push edx
end;

procedure C1;
asm
  pop  edx
  push dword ptr [esp+4]
  jmp  edx
end;

procedure C2;
asm
  pop  edx
  push dword ptr [esp+4*2]
  jmp  edx
end;

procedure C3;
asm
  pop  edx
  push dword ptr [esp+4*3]
  jmp  edx
end;

procedure C4;
asm
  pop  edx
  push dword ptr [esp+4*4]
  jmp  edx
end;

procedure C5;
asm
  pop  edx
  push dword ptr [esp+4*5]
  jmp  edx
end;

procedure C6;
asm
  pop  edx
  push dword ptr [esp+4*6]
  jmp  edx
end;

procedure C2R;
asm
  pop  edx
  pop  eax
  stosd
  jmp  edx
end;

procedure R2C;
asm
  pop  edx
  sub  edi, 4
  push dword ptr [edi]
  jmp  edx
end;

procedure R2CN;
asm
  pop  edx
  pop  ecx
  jecxz @@1
  lea  eax, [ecx*4]
  sub  edi, eax
  mov  eax, edi
@@loo:
  push dword ptr [eax]
  add  eax, 4
  loop @@loo
@@1:
  jmp  edx
end;

procedure CswapR;
asm
  pop  edx
  pop  eax
  xchg eax, [edi-4]
  push eax
  jmp  edx
end;

procedure xySwap;
asm
  mov  eax, [esp+4]
  xchg eax, [esp+8]
  mov  [esp+4], eax
end;

procedure xSwpN;
asm
  pop  ecx
  pop  eax
  pop  edx
  xchg edx, [esp+eax*4]
  push edx
  jmp  ecx
end;

procedure xSwp1;
asm
  mov  eax, [esp+4]
  xchg eax, [esp+8+4]
  mov  [esp+4], eax
end;

procedure xSwp2;
asm
  mov  eax, [esp+4]
  xchg eax, [esp+8+4*2]
  mov  [esp+4], eax
end;

procedure xSwp3;
asm
  mov  eax, [esp+4]
  xchg eax, [esp+8+4*3]
  mov  [esp+4], eax
end;

procedure xSwp4;
asm
  mov  eax, [esp+4]
  xchg eax, [esp+8+4*4]
  mov  [esp+4], eax
end;

procedure xSwp5;
asm
  mov  eax, [esp+4]
  xchg eax, [esp+8+4*5]
  mov  [esp+4], eax
end;

procedure xSwp6;
asm
  mov  eax, [esp+4]
  xchg eax, [esp+8+4*6]
  mov  [esp+4], eax
end;

{$IFDEF Pmacro}
{$IFDEF Psource}
EXIT   PROC INLINE
       PExit
       ENDP
{$ENDIF Psource}
{$IFDEF Psource}
RETURN PROC INLINE
       PReturn
       ENDP
{$ENDIF Psource}
{$IFDEF Psource}
RESULT PROC INLINE
       PResult
       ENDP
{$ENDIF Psource}
{$ENDIF Pmacro}

procedure xyAnd;
asm
  pop  ebx
  pop  eax
  and  [esp], eax
  jmp  ebx
end;

procedure xyOr;
asm
  pop  ebx
  pop  eax
  or   [esp], eax
  jmp  ebx
end;

procedure xyXor;
asm
  pop  ebx
  pop  eax
  xor  [esp], eax
  jmp  ebx
end;

procedure xyNot;
asm
  xor dword ptr [esp+4], -1
end;

procedure xLE0;
asm
  cmp  dword ptr [esp+4], 0
  setle al
  movzx eax, al
  mov [esp+4], eax
end;

procedure xyAdd;
asm
  pop  ebx
  pop  eax
  add  [esp], eax
  jmp  ebx
end;

procedure xySub;
asm
  pop  ebx
  pop  eax
  sub  [esp], eax
  jmp  ebx
end;

procedure xyMul;
asm
  pop  ebx
  pop  eax
  pop  ecx
  imul ecx
  push eax
  jmp  ebx
end;

procedure xyMulMul;
asm
  pop  ebx
  pop  eax
  pop  ecx
  imul ecx
  push eax
  push edx
  jmp  ebx
end;

procedure xyIntDiv;
asm
  pop  ebx
  pop  ecx
  pop  eax
  cdq
  idiv ecx
  push eax
  jmp  ebx
end;

procedure xyDivMod;
asm
  pop  ebx
  pop  ecx
  pop  eax
  cdq
  idiv ecx
  push eax
  push edx
  jmp  ebx
end;

procedure xNeg;
asm
  neg  dword ptr [esp+4]
end;

procedure xyShiftL;
asm
  pop  ebx
  pop  ecx
  pop  eax
  cmp  ecx, 31
  jbe  @@1
  xor  eax, eax
@@1:
  shl  eax, cl
  push eax
  jmp  ebx
end;

procedure xyShiftR;
asm
  pop  ebx
  pop  ecx
  pop  eax
  cmp  ecx, 31
  jbe  @@1
  xor  eax, eax
@@1:
  shr  eax, cl
  push eax
  jmp  ebx
end;

procedure StoreB; // 7 bytes + 1 = 8
asm
  pop ebx
  pop eax
  pop edx
  mov [eax], dl
  jmp ebx
end;

procedure StoreW; // 8 bytes
asm
  pop ebx
  pop eax
  pop edx
  mov [eax], dx
  push ebx
end;

procedure Store; // 6 bytes + 2 = 8
asm
  pop ebx
  pop eax
  pop dword ptr [eax]
  jmp ebx
end;

procedure StoreQ; // 9 bytes + 3 = 12
asm
  pop ebx
  pop eax
  pop dword ptr [eax+4]
  pop dword ptr [eax]
  jmp ebx
end;

procedure StoreVar;
asm
  pop ebx
  lodsd
  pop dword ptr [eax]
  jmp ebx
end;

procedure LoadStack;
asm
  pop  ebx
  push esp
  push ebx
end;

procedure LoadByte; // 8 bytes
asm
  pop ebx
  lodsb
  movzx eax, al
  push eax
  push ebx
end;

procedure LoadSignedByte; // 8
asm
  pop ebx
  lodsb
  movsx eax, al
  push eax
  push ebx
end;

procedure LoadWord; // 8 bytes
asm
  pop ebx
  lodsw
  movzx eax, ax
  push eax
  push ebx
end;

procedure LoadSmallInt; // 8
asm
  pop ebx
  lodsw
  movsx eax, ax
  push eax
  push ebx
end;

procedure Load3; // 15 + 1 = 16
asm
  pop ebx
  lodsw
  bswap eax
  lodsb
  shl  ax, 8
  bswap eax
  push eax
  jmp ebx
end;

procedure Load4; // 5 + 3 = 8
asm
  pop ebx
  lodsd
  push eax
  jmp ebx
end;

procedure Load8; // 7 + 1 = 8
asm
  pop ebx
  lodsd
  push eax
  lodsd
  push eax
  jmp ebx
end;

procedure LoadVar;
asm
  pop ebx
  lodsd
  push dword ptr [eax]
  jmp ebx
end;

procedure Load_Applet;
asm
  pop ebx
  push dword ptr [Applet]
  jmp ebx
end;

procedure Load_hInstance;
asm
  pop ebx
  push dword ptr [hInstance]
  jmp ebx
end;

procedure LoadStr;
asm
  mov  ebx, esi
  xchg ebx, [esp]
@@loo:
  lodsb
  cmp  al, 0
  jnz  @@loo
  push ebx
end;

procedure LoadAnsiStr;
asm
  pop  ebx
  push 0
  mov  eax, esp
  mov  edx, esi
  call System.@LStrFromPChar
  pop  eax
  push eax
  push eax
@@loo:
  lodsb
  cmp  al, 0
  jnz  @@loo
  jmp  ebx
end;

procedure DelAnsiStr;
asm
  pop  ebx
  mov  eax, esp
  call System.@LStrClr
  pop  eax
  push ebx
end;

procedure LoadPCharArray;
asm
  pop  ebx
  pop  ecx
  jecxz @@fin
@@loo1:
  push esi
@@loo2:
  lodsb
  cmp  al, 0
  jnz  @@loo2
  loop @@loo1
@@fin: jmp ebx
end;

procedure SetSELF;
asm
  pop  ebx
  pop  ebp
  push ebp
  jmp  ebx
end;

procedure LoadSELF;
asm
  pop  ebx
  push ebp
  jmp  ebx
end;

procedure SelfOffsetW; // 12
asm
  xor  eax, eax
  lodsw
  add  eax, [edi-8]
  xchg [esp], eax
  push eax
end;

procedure SelfOffsetB; // 11+1 = 12
asm
  xor  eax, eax
  lodsb
  add  eax, [edi-8]
  xchg [esp], eax
  jmp  eax
end;

{$IFDEF Pmacro}
  {$IFDEF Psource}
  L(N) PROC INLINE
IF(N >= -16        AND N <= 15)         #(&N AND 31) 
ELSEIF(N >= 0      AND N <= 255)        Baselib.LoadByte #&N
ELSEIF(N >= -128   AND N <= 127)        Baselib.LoadSignedByte #(&N AND 255)
ELSEIF(N >= 256    AND N <= 65535)      Baselib.LoadWord ##&N
ELSEIF(N >= -32768 AND N <= 32767)      Baselib.LoadSmallInt ##(&N AND $FFFF)
ELSEIF(N >= $10000 AND N <= $FFFFFF)    Baselib.Load3 ###&N
ELSEIF(N >= 0      AND N <= $7FFFFFFF)  Baselib.Load4 ####(&N)
ELSEIF(N < 0       AND (-N) <= $7FFFFFFF) Baselib.Load4 ####(&N)
ELSE                                    Baselib.Load8 ########(&N)
ENDIF
       ENDP
  {$ENDIF Psource}
{$ENDIF Pmacro}

{$IFDEF Pmacro}
  {$IFDEF Psource}
  C(N) PROC INLINE
       IF(N = 1)     Baselib.C1
       ELSEIF(N = 2) Baselib.C2
       ELSEIF(N = 3) Baselib.C3
       ELSEIF(N = 4) Baselib.C4
       ELSEIF(N = 5) Baselib.C5
       ELSEIF(N = 6) Baselib.C6
       ELSE          L(N) Baselib.xCopy
       ENDIF
       ENDP
  {$ENDIF Psource}
{$ENDIF Pmacro}

{$IFDEF Pmacro}
  {$IFDEF Psource}
  DEL(N) PROC INLINE
       IF(N = 1)     DEL
       ELSEIF(N = 2) DEL DEL
       ELSE          L(N) DELN
       ENDIF
       ENDP
  {$ENDIF Psource}
{$ENDIF Pmacro}

{$IFDEF Pmacro}
  {$IFDEF Psource}
Swp(N) PROC INLINE
       IF(N = 1)     Baselib.Swp1
       ELSEIF(N = 2) Baselib.Swp2
       ELSEIF(N = 3) Baselib.Swp3
       ELSEIF(N = 4) Baselib.Swp4
       ELSEIF(N = 5) Baselib.Swp5
       ELSEIF(N = 6) Baselib.Swp6
       ELSE          L(N) Baselib.Swp
       ENDIF
       ENDP
  {$ENDIF Psource}
{$ENDIF Pmacro}

{$IFDEF Pmacro}
  {$IFDEF Psource}
  B(N) PROC INLINE
       #(N)
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  W(N) PROC INLINE
       ##(N)
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  T(N) PROC INLINE
       ###(N)
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  D(N) PROC INLINE
       ####(N)
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  Q(N) PROC INLINE
       ########(N)
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  &    PROC INLINE
       Baselib.xyAnd
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  |    PROC INLINE
       Baselib.xyOr
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  ^    PROC INLINE
       Baselib.xyXor
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  ~    PROC INLINE
       Baselib.xyNot
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  x>=0? PROC INLINE
       Baselib.xLE0
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  +    PROC INLINE
       Baselib.xyAdd
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  -    PROC INLINE
       Baselib.xySub
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  *    PROC INLINE
       Baselib.xyMul
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  /    PROC INLINE
       Baselib.xyIntDiv
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  /:   PROC INLINE
       Baselib.xyDivMod
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  (-)  PROC INLINE
       Baselib.xyNeg
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  **   PROC INLINE
       Baselib.xyMulMul
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  :=   PROC INLINE
       Baselib.Store
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  ^    PROC INLINE
       Baselib.xyIntPow
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  ><   PROC INLINE
       Baselib.xySwap
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  <<   PROC INLINE
       Baselib.xyShiftL
       ENDP
  {$ENDIF Psource}
  {$IFDEF Psource}
  >>   PROC INLINE
       Baselib.xyShiftL
       ENDP
  {$ENDIF Psource}
{$ENDIF Pmacro}

procedure LoadHInstance;
asm
  pop  ebx
  push [hInstance]
  jmp  ebx
end;

procedure LoadRef;
asm
  pop  ebx
  pop  eax
  push dword ptr[eax]
  jmp  ebx
end;

procedure LoadRefByte;
asm
  pop  ebx
  pop  eax
  movzx eax, byte ptr [eax]
  push eax
  jmp  ebx
end;

procedure LoadRefWord;
asm
  pop  ebx
  pop  eax
  movzx eax, word ptr [eax]
  push eax
  jmp  ebx
end;


{$IFDEF Pcode}
procedure AddByte_LoadRef;
{$IFDEF Psource}
AddByte_LoadRef PROC SMART //--by PCompiler:line#924
  Baselib.ParamByte + Baselib.LoadRef
  EXIT
  ENDP
{$ENDIF Psource}
{$I CollapseProcConst.inc}
asm
 CALL RunPCode0
  DB n_Baselib_ParamByte, n_Baselib_xyAdd, n_Baselib_LoadRef
  DB n_PExit
end;
{$ELSE OldCode}
procedure AddByte_LoadRef;
asm
  //
end;
{$ENDIF Pcode}

{$IFDEF Pcode}
procedure AddWord_LoadRef;
{$IFDEF Psource}
AddWord_LoadRef PROC SMART //--by PCompiler:line#945
  Baselib.ParamWord + Baselib.LoadRef
  EXIT
  ENDP
{$ENDIF Psource}
{$I CollapseProcConst.inc}
asm
 CALL RunPCode0
  DB n_Baselib_ParamWord, n_Baselib_xyAdd, n_Baselib_LoadRef
  DB n_PExit
end;
{$ELSE OldCode}
procedure AddWord_LoadRef;
asm
  //
end;
{$ENDIF Pcode}

{$IFDEF Pcode}
procedure AddByte_Store;
{$IFDEF Psource}
AddByte_Store PROC SMART //--by PCompiler:line#966
  Baselib.ParamByte + Baselib.Store
  EXIT
  ENDP
{$ENDIF Psource}
{$I CollapseProcConst.inc}
asm
 CALL RunPCode0
  DB n_Baselib_ParamByte, n_Baselib_xyAdd, n_Baselib_Store
  DB n_PExit
end;
{$ELSE OldCode}
procedure AddByte_Store;
asm
  //
end;
{$ENDIF Pcode}

{$IFDEF Pcode}
procedure AddByte_StoreB;
{$IFDEF Psource}
AddByte_StoreB PROC SMART //--by PCompiler:line#987
  Baselib.ParamByte + Baselib.StoreB
  EXIT
  ENDP
{$ENDIF Psource}
{$I CollapseProcConst.inc}
asm
 CALL RunPCode0
  DB n_Baselib_ParamByte, n_Baselib_xyAdd, n_Baselib_StoreB
  DB n_PExit
end;
{$ELSE OldCode}
procedure AddByte_StoreB;
asm
  //
end;
{$ENDIF Pcode}

{$IFDEF Pcode}
procedure AddWord_Store;
{$IFDEF Psource}
AddWord_Store PROC SMART //--by PCompiler:line#1008
  Baselib.ParamWord + Baselib.Store
  EXIT
  ENDP
{$ENDIF Psource}
{$I CollapseProcConst.inc}
asm
 CALL RunPCode0
  DB n_Baselib_ParamWord, n_Baselib_xyAdd, n_Baselib_Store
  DB n_PExit
end;
{$ELSE OldCode}
procedure AddWord_Store;
asm
  //
end;
{$ENDIF Pcode}

{$IFDEF Pcode}
procedure AddWord_StoreB;
{$IFDEF Psource}
AddWord_Store PROC SMART //--by PCompiler:line#1029
  Baselib.ParamWord + Baselib.StoreB
  EXIT
  ENDP
{$ENDIF Psource}
{$I CollapseProcConst.inc}
asm
 CALL RunPCode0
  DB n_Baselib_ParamWord, n_Baselib_xyAdd, n_Baselib_StoreB
  DB n_PExit
end;
{$ELSE OldCode}
procedure AddWord_StoreB;
asm
  //
end;
{$ENDIF Pcode}

procedure ParamByte;
asm
  pop ebx
  xor eax, eax
  xchg esi, [edi-8]
  lodsb
  xchg esi, [edi-8]
  push eax
  jmp ebx
end;

procedure ParamWord;
asm
  pop ebx
  xor eax, eax
  xchg esi, [edi-8]
  lodsw
  xchg esi, [edi-8]
  push eax
  jmp ebx
end;

procedure Param3;
asm
  pop ebx
  xchg esi, [edi-8]
  lodsd
  dec esi
  xchg esi, [edi-8]
  and eax, $FFFFFF
  push eax
  jmp ebx
end;

procedure Param4;
asm
  pop ebx
  xchg esi, [edi-8]
  lodsd
  xchg esi, [edi-8]
  push eax
  jmp ebx
end;

procedure PASCAL1;
asm
  POP EBX
  POP EAX // EAX= #   ProcTable
  MOV ECX, dword ptr [CollapseProcTable1+EAX*4]
  POP EAX // EAX= 1- 
  PUSH EBX
  JMP ECX
end;

procedure PASCAL2;
asm
  POP EBX
  POP EAX
  MOV ECX, dword ptr [CollapseProcTable2+EAX*4]
  POP EAX
  POP EDX
  PUSH EBX
  JMP ECX
end;

procedure PASCAL3;
asm
  POP EBX
  POP EAX
  MOV ECX, dword ptr [CollapseProcTable3+EAX*4]
  POP EAX
  POP EDX
  XCHG [ESP], EBX
  XCHG ECX, EBX
  JMP EBX
end;

procedure Debug;
asm
  mov  ebp, esi
  inc  esi
  inc  esi
@@loo:
  lodsb
  cmp  al, 0
  jnz  @@loo
end;

end.
