{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit MainDebuger;

//todo: bug-report:       /

interface

{$I KOLDEF.INC}

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL {$IFNDEF KOL_MCK}, mirror, Classes, Controls, mckControls, mckObjs, Graphics,
  mckCtrls {$ENDIF}, err, Source;
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;
{$ENDIF}

const WM_USER_STOPPED = WM_USER;
      RegistryKey = 'Software\Bonanzas\P2Debuger\State\';
      CodeSegmentBase = $401000;

type TDynamicIntArray = array of Integer;

type
  PRetFrame = ^TRetFrame;
  TRetFrame = packed record
    retaddr: Pointer;
    oldself: Pointer;
  end;

  PProcInfo = ^TProcInfo;
  TProcInfo = object( TObj )
    Name: String;
    Offset: Integer;
    Offset1: Integer; // = 1       
    Address: Pointer;
    Length: Integer;
    PrefixSize: Integer; // 1  2
    IdxDebugInfo: Integer;
    IdxDebugLinesInfo: Integer;
    IdxSrc: Integer;
    SourceFileName: String;
    LineSourceFile: Integer;
    destructor Destroy; virtual;
  end;

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} TfmMain = class; PfmMain = TfmMain; {$ELSE OBJECTS} PfmMain = ^TfmMain; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TfmMain.inc}{$ELSE} TfmMain = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TfmMain = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    Panel1: TKOLPanel;
    Panel2: TKOLPanel;
    Label1: TKOLLabel;
    lvRetStack: TKOLListView;
    Splitter1: TKOLSplitter;
    Panel3: TKOLPanel;
    lvCalcStack: TKOLListView;
    Label2: TKOLLabel;
    Splitter2: TKOLSplitter;
    Panel4: TKOLPanel;
    Panel5: TKOLPanel;
    EditBox1: TKOLEditBox;
    lvMemDump: TKOLListView;
    ilCode: TKOLImageList;
    KOLForm1: TKOLForm;
    Panel6: TKOLPanel;
    Panel7: TKOLPanel;
    Panel8: TKOLPanel;
    Toolbar1: TKOLToolbar;
    Toolbar2: TKOLToolbar;
    Panel9: TKOLPanel;
    lvCode: TKOLListView;
    cbUnit: TKOLComboBox;
    L_IP: TKOLLabel;
    pnStatus: TKOLPanel;
    procedure lvCodeResize(Sender: PObj);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure Toolbar1TBTerminateClick(Sender: PControl; BtnID: Integer);
    function KOLForm1Message(var Msg: tagMSG; var Rslt: Integer): Boolean;
    procedure Toolbar1TBAboutClick(Sender: PControl; BtnID: Integer);
    procedure lvRetStackLVData(Sender: PControl; Idx, SubItem: Integer;
      var Txt: String; var ImgIdx: Integer; var State: Cardinal;
      var Store: Boolean);
    procedure Toolbar1TBStepIntoClick(Sender: PControl; BtnID: Integer);
    procedure lvCalcStackLVData(Sender: PControl; Idx, SubItem: Integer;
      var Txt: String; var ImgIdx: Integer; var State: Cardinal;
      var Store: Boolean);
    procedure lvMemDumpResize(Sender: PObj);
    procedure KOLForm1Destroy(Sender: PObj);
    procedure lvCodeLVData(Sender: PControl; Idx, SubItem: Integer;
      var Txt: String; var ImgIdx: Integer; var State: Cardinal;
      var Store: Boolean);
    function lvCodeLVCustomDraw(Sender: PControl; DC: HDC; Stage: Cardinal;
      ItemIdx, SubItemIdx: Integer; const Rect: TRect;
      ItemState: TDrawState; var TextColor, BackColor: Integer): Cardinal;
    procedure Toolbar1TBShowCurIPClick(Sender: PControl; BtnID: Integer);
    procedure Toolbar1TBColorsFontClick(Sender: PControl; BtnID: Integer);
    procedure Toolbar2TBShowStacksClick(Sender: PControl; BtnID: Integer);
    procedure cbUnitChange(Sender: PObj);
    procedure KOLForm1Show(Sender: PObj);
    procedure lvCodeLVStateChange(Sender: PControl; IdxFrom,
      IdxTo: Integer; OldState, NewState: Cardinal);
    procedure KOLForm1Close(Sender: PObj; var Accept: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    CharWidth: Integer;
    procedure Refresh;
    procedure ShowCurInstrPtr;
    procedure SaveRegistry;
    procedure LoadRegistry;
    procedure AssignFont2Children( cParent: PControl );
  public
    SrcList: PStrListEx;
    Src: PSource;
    procedure LoadSourceList;
    procedure ProvideSource( i: Integer );
    procedure FindCurUnit;
    procedure FindCurInstrInSrc;
    procedure AssignAddrToProcBrkPts;
    procedure HandleMapFile( const mappath: String );
  public
    TmpBmp1: PBitmap;
    function CalcTextWidth( Canv: PCanvas; const s: String ): Integer;
  end;

var
  fmMain {$IFDEF KOL_MCK} : PfmMain {$ELSE} : TfmMain {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewfmMain( var Result: PfmMain; AParent: PControl );
{$ENDIF}

procedure CollapseDebug;
procedure InitCollapseDebug( AProjectPath: PChar );

implementation

uses DbgColorsFont;

var FirstExecute: Boolean = TRUE;
    SecondExecute: Boolean = FALSE;
    SrcListReady: Boolean;
    CalcSP_start, RetSP_start, SelfPtr: Pointer;
    CalcSP, RetSP, BaseProc, InstrPtr: Pointer;
    TableProcSize: Integer = 2;
    CurInstrLine: Integer = -1;
    CurInstrOffset: Integer = -1;
    CurSrc: Integer;

    FormsThread: PThread;
    WaitEvent: THandle;
    Stopped: Boolean;

    //ProcList: PList;
    ProjectPath: String;

function CountLeftSpaces( const s: String ): Integer;
var i: Integer;
begin
  Result := 0;
  for i := 1 to Length( s ) do
    if s[ i ] <= ' ' then Inc( Result )
    else break;
end;

function ExecuteThread( DummySelf: PObj; Sender: PThread ): Integer;
begin
  Applet := NewApplet( '' );
  AppletRunning := TRUE;
  NewfmMain( fmMain, Applet );
  fmMain.Form.ShowModal;
  fmMain.SaveRegistry;
  Free_And_Nil( Applet );
  TerminateProcess( GetCurrentProcess, 0 );
  Result := 0;
end;

procedure DebugCommand( aIP, aRetSP, aSelfPtr, aCalcSP: Pointer );
begin
  {ShowMessage( 'IP:' + Int2Hex( DWORD( IP ), 6 ) +
               ' RetSP:' + Int2Hex( DWORD( RetSP ), 6 ) +
               ' SelfPtr:' + Int2Hex( DWORD( SelfPtr ), 6 ) +
               ' CalcSP:' + Int2Hex( DWORD( CalcSP ), 6 ) );}
  if FirstExecute then
  begin
    //-----  ,    
    RetSP_start := aRetSP;
    CalcSP_start := Pointer( DWORD( aCalcSP ) + 40 );
    CalcSP := Pointer( DWORD( aCalcSP ) + 4 );
    RetSP := aRetSP;
    SelfPtr := aSelfPtr;
    InstrPtr := aIP;
    //-----  ,       
    //         
    WaitEvent := CreateEvent( nil, FALSE, FALSE, nil );
    //Stopped := TRUE;
    FormsThread := NewThread;
    FormsThread.OnExecute := TOnThreadExecute( MakeMethod( nil, @ ExecuteThread ) );
    FormsThread.Resume;
    while //(fmMain=nil) or (fmMain.Form=nil) or (fmMain.Form.Handle=0)
          not SrcListReady
      do
      Sleep( 0 );
  end;
    //else
    Stopped := TRUE;
  if SecondExecute then
  begin
    SecondExecute := FALSE;
    //fmMain.HandleMapFile;
  end;
  if FirstExecute then
    SecondExecute := TRUE;
  FirstExecute := FALSE;
  if Stopped then
  begin
    CalcSP := Pointer( Integer( aCalcSP ) + 4 );
    RetSP := aRetSP;
    SelfPtr := aSelfPtr;
    InstrPtr := aIP;
    PostMessage( fmMain.Form.Handle, WM_USER_STOPPED, 0, 0 );
    WaitForSingleObject( WaitEvent, INFINITE );
  end;
  {ShowMessage( 'IP:' + Int2Hex( DWORD( IP ), 6 ) +
               ' RetSP:' + Int2Hex( DWORD( RetSP ), 6 ) +
               ' BaseProc:' + Int2Hex( DWORD( BaseProc ), 6 ) +
               ' CalcSP:' + Int2Hex( DWORD( CalcSP ), 6 ) );}
end;

procedure CollapseDebug;
asm
  mov eax, esi // IP
  mov edx, edi // retstack
  mov ecx, ebp // self obj ptr
  push esp     // calc stack
  call DebugCommand
end;

procedure InitCollapseDebug( AProjectPath: PChar );
begin
  ProjectPath := AProjectPath;
end;

procedure ReplaceTabs( var s: String; var n: TDynamicIntArray );
var i, j, k: Integer;
begin
  while TRUE do
  begin
    i := pos( #9, s );
    if i <= 0 then Exit;
    j := (i + 8) and not 7 - i;
    s := Copy( s, 1, i-1 ) + StrRepeat( ' ', j ) + CopyEnd( s, i+1 );
    SetLength( n, Length( s ) );
    for k := High( n ) downto i+j-2 do
      n[ k ] := n[ k-j+1 ];
    for k := i-1 to i + j - 3 do
      n[ k ] := 0;
  end;
end;

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I MainDebuger_1.inc}
{$ENDIF}

procedure TfmMain.lvCodeResize(Sender: PObj);
begin
  lvCode.LVColWidth[ 1 ] := lvCode.ClientWidth - lvCode.LVColWidth[ 0 ] -1;
end;

procedure TfmMain.KOLForm1FormCreate(Sender: PObj);
begin
  Form.ExStyle := Form.ExStyle or WS_EX_APPWINDOW;
  LoadRegistry;
  //PrepareSourceForDebug;
  SrcList := NewStrListEx;
  LoadSourceList;
end;

procedure TfmMain.Toolbar1TBTerminateClick(Sender: PControl;
  BtnID: Integer);
begin
  Form.Close;
end;

function TfmMain.KOLForm1Message(var Msg: tagMSG;
  var Rslt: Integer): Boolean;
begin
  Result := FALSE;
  CASE Msg.message OF
  WM_USER_STOPPED:
    begin
      Toolbar1.TBButtonEnabled[ TBStop ] := FALSE;
      Toolbar1.TBButtonEnabled[ TBStepInto ] := TRUE;
      Toolbar1.TBButtonEnabled[ TBStepOver ] := TRUE;
      Toolbar1.TBButtonEnabled[ TBRun ] := TRUE;
      Toolbar1.TBButtonEnabled[ TBShowCurIP ] := TRUE;
      Refresh;
      Result := TRUE;
    end;
  WM_KEYDOWN:
    begin
      CASE Msg.WParam OF
      VK_F6: Toolbar1TBShowCurIPClick( nil, 0 );
      VK_F7: Toolbar1TBStepIntoClick( nil, 0 );
      //todo:  VK_*
      END;
    end;
  END;
end;

procedure TfmMain.Toolbar1TBAboutClick(Sender: PControl; BtnID: Integer);
begin
  ShowMessage( 'PDebuger (c) by Vladimir Kladov, 2005'#13#13 +
               'PDebuger debugs virtual machine which coopertes with PC real '#13 +
               'machine via its emulator. EmualtePcode calls this PDebuger, if'#13+
               'the project is compiled in /D[EBUG] and in such ase '#13 +
               'it calls this PDebuger before each P-machine instruction allowing '#13 +
               'it to control execution flow. Only P-code can be stepped '#13 +
               'into, not assembler or other compiled machine code procedures.' )
end;

procedure TfmMain.Refresh;
var RetStk_FrameCount: Integer;
    RetFrame: PRetFrame;
begin
  RetStk_FrameCount := 1;
  RetFrame := RetSP;
  while RetFrame.retaddr <> nil do
  begin
    Inc( RetStk_FrameCount );
    Dec( RetFrame );
  end;
  lvRetStack.LVCount := RetStk_FrameCount;
  FindCurUnit;
  FindCurInstrInSrc;
  lvRetStack.Invalidate;
  lvCode.Invalidate;
  lvCalcStack.LVCount := (DWORD( CalcSP_start ) - DWORD( CalcSP )) div 4;
  L_IP.Caption := Int2Hex( DWORD( InstrPtr ), 6 );
end;

procedure TfmMain.lvRetStackLVData(Sender: PControl; Idx, SubItem: Integer;
  var Txt: String; var ImgIdx: Integer; var State: Cardinal;
  var Store: Boolean);
var RetFrame: PRetFrame;
    i, j, L: Integer;
    P: PChar;
    unitpath, s: String;
    unitsrc: PStrListEx;
    Value_InProc, Value_Self: Pointer;
begin
  i := lvRetStack.LVCount - Idx - 1;
  RetFrame := RetSP;
  Value_InProc := InstrPtr;
  Value_Self := SelfPtr;
  while i >= 0 do
  begin
    if RetFrame.RetAddr = nil then
    begin
      Dec( RetFrame );
      Value_InProc := Pointer( RetFrame.oldself );
      Value_Self := nil;
      break;
    end
      else
    begin
      Value_InProc := RetFrame.retaddr;
      Value_Self := RetFrame.oldself;
      Dec( RetFrame );
    end;
    Dec( i );
  end;

  TRY
  CASE SubItem OF
  ColRetAddr     :
      if RetFrame.RetAddr = nil then
      begin
        Dec( RetFrame );
        Txt := '* ' + Int2Hex( DWORD( RetFrame.oldself ), 6 );
      end
        else
        Txt := Int2Hex( DWORD( RetFrame.RetAddr ), 6 );
  ColSelf        : Txt := Int2Hex( DWORD( Value_Self ), 6 );
  ColCalcStackTop: Txt := '?'; //Int2Hex( RetFrame.SaveESP, 6 );
  ColInProc      :
    begin
      Txt := '';
      {P := Pointer( Value_BaseProc );
      L := PWord( P )^; // L =  
      Inc( P, 2 );      // P =   
      unitpath := P;
      for i := 0 to SrcList.Count-1 do
      begin
        if StrEq( SrcList.Items[ i ], unitpath ) then
        begin
          unitsrc := Pointer( SrcList.Objects[ i ] );
          if unitsrc <> nil then
          begin
            for j := L-1 downto 0 do
            begin
              s := LowerCase( Trim( unitsrc.Items[ j ] ) );
              if StrIsStartingFrom( PChar( s ), 'procedure ' ) or
                 StrIsStartingFrom( PChar( s ), 'function' ) then
              begin
                s := Trim( unitsrc.Items[ j ] );
                Parse( s, ' ' ); s := Trim( s );
                s := Trim( Parse( s, ' ({/;'#9 ) );
                Txt := s + '(' + ExtractfileName( unitpath ) + ')';
                break;
              end;
            end;
          end;
          break;
        end;
      end;}
    end;
  END;
  EXCEPT
    Txt := '';
  END;
end;

procedure TfmMain.Toolbar1TBStepIntoClick(Sender: PControl;
  BtnID: Integer);
begin
  Toolbar1.TBButtonEnabled[ TBStop ] := TRUE;
  Toolbar1.TBButtonEnabled[ TBStepInto ] := FALSE;
  Toolbar1.TBButtonEnabled[ TBStepOver ] := FALSE;
  Toolbar1.TBButtonEnabled[ TBRun ] := FALSE;
  Toolbar1.TBButtonEnabled[ TBShowCurIP ] := FALSE;
  SetEvent( WaitEvent );
end;

procedure TfmMain.lvCalcStackLVData(Sender: PControl; Idx,
  SubItem: Integer; var Txt: String; var ImgIdx: Integer;
  var State: Cardinal; var Store: Boolean);
var SP: PByte;
    S: String;
    i: Integer;
begin
  SP := Pointer( Integer( CalcSP ) + 4 * Idx );
  CASE SubItem OF
  ColStackPos: Txt := Int2Hex( DWORD( SP ), 6 );
  ColValue   : Txt := Int2Hex( PDWORD( SP )^, 6 );
  ColMemory  :
    begin
      S := '';
      TRY
        SP := Pointer( PDWORD( SP )^ );
        for i := 1 to 16 do
        begin
          S := S + Int2Hex( SP^, 2 ) + ' ';
          if PChar( SP )^ in [ ' '..#255 ] then
            S := S + PChar( SP )^
          else
            S := S + '?';
          S := S + ' ';
          Inc( SP );
        end;
      EXCEPT
      END;
      Txt := S;
    end;
  END;
end;

procedure TfmMain.lvMemDumpResize(Sender: PObj);
begin
  lvMemDump.LVColWidth[ 0 ] := lvMemDump.ClientWidth-1;
end;

procedure TfmMain.KOLForm1Destroy(Sender: PObj);
var i: Integer;
begin
  //ProcList.ReleaseObjects;
  for i := 0 to SrcList.Count-1 do
  begin
    if SrcList.Objects[ i ] <> 0 then
      PObj( PObj( SrcList.Objects[ i ] ).Tag ).Free;
    PObj( SrcList.Objects[ i ] ).Free;
  end;
  SrcList.Free;
end;

procedure TfmMain.lvCodeLVData(Sender: PControl; Idx, SubItem: Integer;
  var Txt: String; var ImgIdx: Integer; var State: Cardinal;
  var Store: Boolean);
var Addr, LastAddr: PByte;
    i: Integer;
    s: String;
begin
  if Src = nil then Exit;
  CASE SubItem OF
  ColCode:
    begin
      Txt := '';
      ImgIdx := -1;
      State := 0;
      if Integer( Src.Lines.Objects[ Idx ] ) >= 0 then
      begin
        State := 2 shl 12;
        if Src.Lines.Objects[ Idx ] and $FF000000 <> 0 then
          State := 3 shl 12;
        FindCurInstrInSrc;
        Addr := Pointer( Src.BrkPts.Objects[ Src.Lines.Objects[ Idx ] and $FFFFFF ] );
        if Addr <> nil then
        begin
          LastAddr := Addr;
          for i := (Src.Lines.Objects[ Idx ] and $FFFFFF + 1) to Src.BrkPts.Count-1 do
          begin
            s := Src.BrkPts.Items[ i ];
            if pos( '*', s ) > 0 then continue;
            if pos( '+', s ) > 0 then continue;
            LastAddr := Pointer( Src.BrkPts.Objects[ i ] );
            if LastAddr <> nil then break;
          end;
          if LastAddr = nil then
            LastAddr := Pointer( Integer( Addr ) + 1 );
          while (Addr <> LastAddr) and (Length( Txt ) < 512) do
          begin
            TRY
              Txt := Txt + Int2Hex( Addr^, 2 );
            EXCEPT
              LastAddr := Addr;
              Dec( Addr );
            END;
            Inc( Addr );
          end;
        end;
      end;
      if CurInstrLine = Idx then
        ImgIdx := 3;
    end;
  ColText:
    begin
      Txt := Src.Lines.Items[ Idx ];
    end;
  END;
end;

{ TProcInfo }

destructor TProcInfo.Destroy;
begin
  Name := '';
  SourceFileName := '';
  inherited;
end;

function TfmMain.lvCodeLVCustomDraw(Sender: PControl; DC: HDC;
  Stage: Cardinal; ItemIdx, SubItemIdx: Integer; const Rect: TRect;
  ItemState: TDrawState; var TextColor, BackColor: Integer): Cardinal;
    procedure ProvideColors( CurInstr: Boolean = FALSE );
    begin
      if CurInstr then
      begin
        Sender.Canvas.Brush.Color := clRed;
        Sender.Canvas.Font.Color := clYellow;
      end
        else
      if odsSelected in ItemState then
      begin
        if LVCode.Focused then
        begin
          Sender.Canvas.Brush.Color := clHighlight;
          Sender.Canvas.Font.Color := clHighlightText;
        end
          else
        begin
          Sender.Canvas.Brush.Color := Color2RGB( clBtnFace );
          Sender.Canvas.Font.Color := clWindowText;
        end;
      end
        else
      begin
        Sender.Canvas.Brush.Color := clWindow;
        Sender.Canvas.Font.Color := clWindowText;
      end;
      Sender.Canvas.DeselectHandles;
    end;

var i, j, L, L1, L2, L3: Integer;
    Txt, s: String;
    SelTxtBegin, SelTxtLength: Integer;
    R, R0: TRect;
    Addr, LastAddr: PByte;
    unitsrc: PSource;
    procname: String;
    procstart: Integer;
    itiscurrent: Boolean;
begin
  if (Stage = CDDS_PREPAINT) then
    Result := CDRF_NOTIFYITEMDRAW
  else
  if (Stage = CDDS_ITEMPREPAINT) and (ItemIdx >= 0) then
    Result := CDRF_NOTIFYSUBITEMDRAW
  else
  if (Stage = (CDDS_ITEMPREPAINT or CDDS_SUBITEM)) and
     (ItemIdx >= 0) and (SubItemIdx >= 0) then
  begin
    if CharWidth = 0 then
      CharWidth := Sender.Canvas.TextWidth('WAM') div 3;
    Result := CDRF_SKIPDEFAULT;

    R := Sender.LVSubItemRect( ItemIdx, SubItemIdx );
    if R.Bottom < 0 then Exit;

    procstart := 0;
    procname := '';
    unitsrc := Pointer( SrcList.Objects[ cbUnit.CurIndex ] );
    for i := 0 to unitsrc.ProcList.Count-1 do
    begin
      if unitsrc.ProcList.Objects[ i ] <= ItemIdx then
      begin //  ,     () 
        procname := unitsrc.ProcList.Items[ i ];
        procstart := unitsrc.ProcList.Objects[ i ];
        break;
      end;
    end;

    itiscurrent := FALSE;
    SelTxtBegin := -1;
    SelTxtLength := 0;
    CASE SubItemIdx OF
    ColCode:
      begin
        Txt := '';
        Addr := nil;
        if Integer( unitsrc.Lines.Objects[ ItemIdx ] ) <> -1 then
          Addr := Pointer( unitsrc.BrkPts.Objects[ unitsrc.Lines.Objects[ ItemIdx ] and $FFFFFF ] );
        if Addr <> nil then
        begin
          LastAddr := nil;
          for i := ItemIdx+1 to Min( ItemIdx + 100, Src.Lines.Count-1 ) do
          begin
            if Integer( unitsrc.Lines.Objects[ i ] ) <> -1 then
            begin
              LastAddr := Pointer( unitsrc.BrkPts.Objects[ unitsrc.Lines.Objects[ i ] and $FFFFFF ] );
              break;
            end;
          end;
          if LastAddr = nil then
          begin
            LastAddr := Addr;
            for i := (Src.Lines.Objects[ ItemIdx ] and $FFFFFF + 1) to unitsrc.BrkPts.Count-1 do
            begin
              s := unitsrc.BrkPts.Items[ i ];
              if pos( '*', s ) > 0 then continue;
              if pos( '+', s ) > 0 then continue;
              LastAddr := Pointer( unitsrc.BrkPts.Objects[ i ] );
              if LastAddr <> nil then break;
            end;
          end;
          if LastAddr = nil then
            LastAddr := Pointer( Integer( Addr ) + 1 );
          while DWORD( Addr ) < DWORD( LastAddr ) do
          begin
            if Txt = '' then
              Txt := Int2Hex( DWORD( Addr ), 6 ) + ' ';
            TRY
              if Addr = InstrPtr then
              begin
                itiscurrent := TRUE;
                SelTxtBegin := Length( Txt );
                SelTxtLength := 2;
              end;
              Txt := Txt + Int2Hex( Addr^, 2 );
            EXCEPT
              LastAddr := Addr;
              Dec( Addr );
            END;
            Inc( Addr );
          end;
        end;
      end;
    ColText: Txt := Src.Lines.Items[ ItemIdx ];
    END;

    ProvideColors( FALSE );

    //if Txt <> '' then
    begin
      i := unitsrc.Lines.Objects[ ItemIdx ];
      if i >= 0 then
      begin
        i := i and $FFFFFF;
        s := unitsrc.BrkPts.Items[ i ];
        //Addr := Pointer( BrkPts.Objects[ i ] );
        Parse( s, ' ' );
      end
      else
      begin
        s := '';
        //Addr := nil;
      end;
      //Addr0 := Addr;
      CASE SubItemIdx OF
      ColCode:
        begin
          Sender.Canvas.Brush.Color := clWindow;
          Sender.Canvas.Font.Color := clWindowText;
          R0 := R;
          R0.Right := R0.Left + 32;
          R.Left := R0.Right;
          Sender.Canvas.FillRect( R0 );
          if Src.Lines.Objects[ ItemIdx ] and $FF000000 = $80 then
            ilCode.Draw( 2, Sender.Canvas.Handle, R0.Left, R0.Top )
          else
          if Src.Lines.Objects[ ItemIdx ] and $FF000000 = $C0000000 then
            ilCode.Draw( 4, Sender.Canvas.Handle, R0.Left, R0.Top )
          else
          if Integer( Src.Lines.Objects[ ItemIdx ] ) >= 0 then
            ilCode.Draw( 1, Sender.Canvas.Handle, R0.Left, R0.Top );
          if {(ItemIdx = CurInstrLine) and (CurSrc = cbUnit.CurIndex)}
             itiscurrent then
            ilCode.Draw( 3, Sender.Canvas.Handle, R0.Left + 16, R0.Top );

          ProvideColors( FALSE );
          if SelTxtBegin >= 0 then
          begin
            s := Copy( Txt, 1, SelTxtBegin );
            L1 := 0;
            if s <> '' then
            begin
              L1 := CalcTextWidth( Sender.Canvas, s );
              Sender.Canvas.TextRect(
                MakeRect( R.Left, R.Top, R.Left + L1, R.Bottom ),
                R.Left, R.Top, s );
            end;
            ProvideColors( TRUE );
            s := Copy( Txt, SelTxtBegin + 1, SelTxtLength );
            L2 := CalcTextWidth( Sender.Canvas, s );
            Sender.Canvas.TextRect(
              MakeRect( R.Left + L1, R.Top, R.Left + L1 + L2, R.Bottom ),
              R.Left + L1, R.Top, s );
            s := CopyEnd( Txt, SelTxtBegin + SelTxtLength + 1 );
            if s <> '' then
            begin
              L3 := CalcTextWidth( Sender.Canvas, s );
              ProvideColors( FALSE );
              Sender.Canvas.TextRect(
                MakeRect( R.Left + L1 + L2, R.Top, R.Right, R.Bottom ),
                R.Left + L1 + L2, R.Top, s );
            end;
          end
            else
            Sender.Canvas.TextRect( R, R.Left, R.Top, Txt );
        end;
      ColText:
        begin
          ProvideColors( FALSE );
          Sender.Canvas.TextRect( R, R.Left, R.Top, Txt );
          if ( CurSrc = cbUnit.CurIndex ) and
             (CurInstrLine = ItemIdx) and (CurInstrOffset >= 0) then
          begin
            s := CopyEnd( Txt, CurInstrOffset+1 );
            if s <> '' then
            begin
              if s[ 1 ] = '''' then
              begin
                for j := 2 to Length( s ) do
                  if (s[ j ] = '''') and (j < Length( s )) and
                     (s[ j+1 ] <> '''') then
                  begin
                    s := Copy( s, 1, j );
                    break;
                  end;
              end
                else
              begin
                L := 0;
                for j := 1 to Length( s ) do
                begin
                  CASE s[ j ] OF
                  '(': inc( L );
                  ')': dec( L );
                  ' ': if L <= 0 then
                       begin
                         s := Copy( s, 1, j-1 );
                         break;
                       end;
                  END;
                end;
                //s := Parse( s, ' ' ) + ' ';
              end;
            end;
            if s <> '' then
            begin
              s := ' ' + s;
              if s[ Length( s ) ] <> ' ' then s := s + ' ';
              ProvideColors( TRUE );
              R0 := R;
              Inc( R0.Left, (CurInstrOffset-1) * CharWidth );
              R0.Right := R0.Left + Length( s ) * CharWidth;
              Sender.Canvas.TextRect( R0, R0.Left, R0.Top, s );
            end;
          end;
          ProvideColors( FALSE );
          //Sender.Canvas.TextRect( R, R.Left, R.Top, Txt );
          Sender.Canvas.Brush.Color := clBlue;
          Sender.Canvas.FillRect( MakeRect( R.Left, R.Top, R.Left+1, R.Bottom ) );
        end;
      END;
    end
      {else
    begin
      if SubItemIdx = 1 then
      begin
        R0 := R;
        Inc( R.Left );
        Sender.Canvas.TextRect( R, R.Left, R.Top, Txt );
        Sender.Canvas.Brush.Color := clBlue;
        Sender.Canvas.FillRect( MakeRect( R0.Left, R0.Top, R0.Left+1, R0.Bottom ) );
      end
        else
      begin
        Sender.Canvas.TextRect( R, R.Left, R.Top, Txt );
      end;
    end};

    Sender.Canvas.Brush.Color := clGreen; // clWindow;
    Sender.Canvas.Font.Color := clWindowText;
  end
    else
    Result := CDRF_DODEFAULT;
end;

{function TfmMain.RecodeDebugInfo( const d: String;
  const n: TDynamicIntArray): String;
var s: String;
    i, j: Integer;
begin
  s := PChar( d );
  Result := Parse( s, ' ' ) + ' ';
  while s <> '' do
  begin
    i := Str2Int( s );
    Parse( s, ' ' );
    for j := 0 to High( n ) do
      if n[ j ] >= i then
      begin
        i := j + 1;
        break;
      end;
    Result := Result + Int2Str( i ) + ' ';
    Result := Result + Parse( s, ' ' ) + ' ';
    Result := Result + Parse( s, ';' ) + '; ';
    s := Trim( s );
  end;
end;}

procedure TfmMain.Toolbar1TBShowCurIPClick(Sender: PControl;
  BtnID: Integer);
begin
  ShowCurInstrPtr;
  lvCode.Invalidate;
end;

procedure TfmMain.ShowCurInstrPtr;
begin
  if CurInstrLine < 0 then Exit;
  lvCode.LVCurItem := -1;
  lvCode.LVCurItem := CurInstrLine;
  if (lvCode.LVTopItem <= CurInstrLine) and
     (CurInstrLine < lvCode.LVTopItem + lvCode.LVPerPage) then Exit;
  lvCode.LVMakeVisible( Min( lvCode.LVCount-1, CurInstrLine + lvCode.LVPerPage div 2),
    FALSE );
  lvCode.LVMakeVisible( Max( 0, CurInstrLine - lvCode.LVPerPage div 2 ), FALSE );
  lvCode.LVMakeVisible( CurInstrLine, FALSE );
end;

procedure TfmMain.Toolbar1TBColorsFontClick(Sender: PControl;
  BtnID: Integer);
begin
  if fmColorsFont = nil then
    NewfmColorsFont( fmColorsFont, Applet );
  fmColorsFont.Form.ShowModal;
  fmColorsFont.Form.Free;
  fmColorsFont := nil;
end;

procedure TfmMain.SaveRegistry;
var R: THandle;
    procedure SaveColsWidth( const lvName: String; lv: PControl );
    var i: Integer;
    begin
      for i := 0 to lv.LVColCount-1 do
        RegKeySetDw( R, lvName + '.Col' + Int2Str( i ), lv.LVColWidth[ i ] );
    end;
begin
  R := RegKeyOpenCreate( HKEY_CURRENT_USER, RegistryKey );
  TRY
    RegKeySetStr( R, 'FontName', Form.Font.FontName );
    RegKeySetDw( R, 'FontHeight', Form.Font.FontHeight );
    RegKeySetDw( R, 'FontWidth', Form.Font.FontWidth );
    RegKeySetDw( R, 'Left', Form.Left );
    RegKeySetDw( R, 'Top', Form.Top );
    RegKeySetDw( R, 'Width', Form.Width );
    RegKeySetDw( R, 'Height', Form.ClientHeight );
    SaveColsWidth( 'RetStack', lvRetStack );
    SaveColsWidth( 'CalcStack', lvCalcStack );
  FINALLY
    RegKeyClose( R );
  END;
end;

procedure TfmMain.LoadRegistry;
var R: THandle;
    procedure LoadColsWidth( const lvName: String; lv: PControl );
    var i: Integer;
    begin
      for i := 0 to lv.LVColCount-1 do
        lv.LVColWidth[ i ] := RegKeyGetDw( R, lvName + '.Col' + Int2Str( i ) );
    end;
begin
  R := RegKeyOpenRead( HKEY_CURRENT_USER, RegistryKey );
  if R <> 0 then
  TRY
    Form.Font.FontName := RegKeyGetStr( R, 'FontName' );
    Form.Font.FontHeight := RegKeyGetDw( R, 'FontHeight' );
    Form.Font.FontWidth := RegKeyGetDw( R, 'FontWidth' );

    AssignFont2Children( Form );
    lvCode.LVItemHeight := Form.Font.FontHeight;

    Form.Left := RegKeyGetDw( R, 'Left' );
    Form.Top := RegKeyGetDw( R, 'Top' );
    Form.Width := RegKeyGetDw( R, 'Width' );
    Form.ClientHeight := RegKeyGetDw( R, 'Height' );
    LoadColsWidth( 'RetStack', lvRetStack );
    LoadColsWidth( 'CalcStack', lvCalcStack );
  FINALLY
    RegKeyClose( R );
  END;
end;

procedure TfmMain.Toolbar2TBShowStacksClick(Sender: PControl;
  BtnID: Integer);
begin
  Panel1.Visible := Toolbar2.TBButtonChecked[ TBShowStacks ];
end;

procedure TfmMain.AssignFont2Children(cParent: PControl);
var i: Integer;
    c: PControl;
begin
  for i := 0 to cParent.ChildCount-1 do
  begin
    c := cParent.Children[ i ];
    c.Font.Assign( cParent.Font );
    AssignFont2Children( c );
  end;
end;

procedure TfmMain.LoadSourceList;
var P: PChar;
    Path: String;
    DL: PDirList;
    s: String;
    SL: PStrList;
    i: Integer;
begin
  //    ,  ,  InstrPtr ->  ,
  //      Debug.
  Path := ProjectPath;
  DL := NewDirList( Path, '*.debug', FILE_ATTRIBUTE_NORMAL );
  TRY
    DL.Sort( [ ] );
    for i := 0 to DL.Count-1 do
    begin
      s := DL.Names[ i ];
      Delete( s, Length( s ) - 5, 6 );
      SrcList.Add( DL.Path + s );
      cbUnit.Add( ExtractfileName( s ) );
    end;
  FINALLY
    DL.Free;
  END;
  s := Path + 'Pcompiler.cfg';
  if FileExists( s ) then
  begin
    SL := NewStrList;
    TRY
      SL.LoadFromFile( s );
      for i := 0 to SL.Count-1 do
      begin
        s := SL.Items[ i ];
        if StrEq( Copy( s, 1, 2 ), '/B' ) then
        begin
          s := Path + CopyEnd( s, 3 );
          if not FileExists( s ) and DirectoryExists( s ) then
            s := IncludeTrailingPathDelimiter( s ) + 'baselib.pas';
          if FileExists( s ) and FileExists( s + '.debug' ) then
          begin
            SrcList.Add( s );
            cbUnit.Add( ExtractfileName( s ) );
          end;
        end;
        if StrEq( Copy( s, 1, 2 ), '/M' ) then
        begin
          HandleMapFile( Path + CopyEnd( s, 3 ) );
        end;
      end;
    FINALLY
      SL.Free;
    END;
  end;
  SrcListReady := TRUE;
end;

procedure TfmMain.cbUnitChange(Sender: PObj);
begin
  ProvideSource( cbUnit.CurIndex );
  Src := Pointer( SrcList.Objects[ cbUnit.CurIndex ] );
  lvCode.LVCount := Src.Lines.Count;
  lvCode.Invalidate;
end;

procedure TfmMain.ProvideSource( i: Integer );
var j, k: Integer;
    s, s1: String;
begin
  if i < 0 then Exit;
  if SrcList.Objects[ i ] = 0 then
  begin
    new( Src, Create );
    SrcList.Objects[ i ] := DWORD( Src );
    s := SrcList.Items[ i ];
    Src.Path := s;
    //Src.Lines.LoadFromFile( s );
    //Src.BrkPts.LoadFromFile( SrcList.Items[ i ] + '.debug' );
    Src.Load;
    {for j := 0 to Src.Lines.Count-1 do
      Src.Lines.Objects[ j ] := DWORD( -1 );
    for j := 0 to Src.BrkPts.Count-1 do
    begin
      s := Src.BrkPts.Items[ j ];
      if (pos( '+', s ) <= 0) and (pos( '*', s ) <= 0) then
      begin
        k := Str2Int( s );
        s1 := Src.Lines.Items[ j ]; //   !
        Src.Lines.Objects[ k-1 ] := j;
      end;
    end;}
  end;
  //Src := Pointer( SrcList.Objects[ i ] );
end;

procedure TfmMain.KOLForm1Show(Sender: PObj);
begin
  if lvCode.Count = 0 then
  begin
    ProvideSource( cbUnit.CurIndex );
    Src := Pointer( SrcList.Objects[ cbUnit.CurIndex ] );
    if Src = nil then Exit;
    lvCode.LVCount := Src.Lines.Count;
    lvCode.Invalidate;
  end;
end;

procedure TfmMain.FindCurInstrInSrc;
var P: PChar;
    L: Word;
    i, j, n, m: Integer;
    unitpath, s: String;
    InstrFound: Boolean;
    off_in_proc, off_in_line: Integer;
    ProcOffset: Integer;
begin
  P := Pointer( InstrPtr );
  L := PWord( P )^;
  Inc( P, 2 );
  unitpath := P;
  for i := 0 to SrcList.Count-1 do
  begin
    //if Src = Pointer( SrcList.Objects[ i ] ) then
    if StrEq( unitpath, SrcList.Items[ i ] ) then
    begin
      CurSrc := i;
      {if not StrEq( unitpath, SrcList.Items[ i ] ) then
      begin
        CurInstrLine := -1;
        break;
      end;}
      ProcOffset := DWORD( InstrPtr ) - DWORD( BaseProc ) + 2;
      off_in_proc := -1;
      InstrFound := FALSE;
      for j := Src.Lines.Objects[ L ] and $FFFFFF to Src.BrkPts.Count-1 do
      begin
        s := Src.BrkPts.Items[ j ];
        if pos( '*', s ) > 0 then continue;
        if pos( '+', s ) > 0 then continue;
        n := Str2Int( s );
        Parse( s, ' '#9 ); s := Trim( s );
        while s <> '' do
        begin
          off_in_line := Str2Int( s );
          Parse( s, ':' );
          m := Str2Int( s );
          Parse( s, ' '#9 ); s := Trim( s );
          if m < off_in_proc then
            break;
          if (m >= ProcOffset) and (off_in_proc <= ProcOffset) then
          begin
            CurInstrLine := n-1;
            CurInstrOffset := off_in_line;
            InstrFound := TRUE;
            if Src.BrkPts.Objects[ L ] = 0 then
              AssignAddrToProcBrkPts;
            break;
          end;
          off_in_proc := m;
        end;
        if InstrFound then break;
      end;
      break;
    end;
  end;
end;

procedure TfmMain.AssignAddrToProcBrkPts;
var P: PChar;
    L: Word;
    i, m, off_in_code: Integer;
    s: String;
begin
  //ProcOffset := DWORD( InstrPtr ) - DWORD( BaseProc );
  P := Pointer( BaseProc );
  L := PWord( P )^;
  m := 0;
  for i := (Src.Lines.Objects[ L ] and $FFFFFF)-1 to Src.BrkPts.Count-1 do
  begin
    s := Src.BrkPts.Items[ i ];
    if pos( '*', s ) > 0 then continue;
    if pos( '+', s ) > 0 then continue;
    //n := Str2Int( s );
    Parse( s, ' '#9 ); s := Trim( s );
    Parse( s, ':' ); s := Trim( s );
    off_in_code := Str2Int( s );
    if off_in_code < m then break;
    Src.BrkPts.Objects[ i ] := Integer( BaseProc ) + off_in_code - 2;
    m := off_in_code;
  end;
end;

procedure TfmMain.HandleMapFile( const mappath: String );
var SL: PStrList;
    i, j, k, n, m, line, line1, line2, seg, addr, brkline: Integer;
    s: String;
    proc: PProcInfo;
    procname: String;
    procstartline: Integer;
    procstartaddr: Pointer;
    unitname: String;
begin //
  if FileExists( mappath ) then
  begin
    {if ProcList = nil then
      ProcList := NewList;}
    SL := NewStrList;
    TRY
      SL.LoadFromFile( mappath );
      for i := 0 to SL.Count-1 do
      begin
        s := Trim( SL.Items[ i ] );
        if StrEq( Copy( s, 1, 12 ), 'Line numbers' ) then
        begin
          Parse( s, '(' );
          s := Trim( Parse( s, ')' ) ); // unit name in s
          for n := 0 to SrcList.Count-1 do
          begin
            if StrEq( s, ExtractFileName( SrcList.Items[ n ] ) ) then
            begin //  unit
              unitname := s;
              ProvideSource( n );
              Src := Pointer( SrcList.Objects[ n ] );
              for k := i+1 to SL.Count-1 do
              begin
                s := Trim( SL.Items[ k ] );
                if s = '' then continue;
                if StrEq( Copy( s, 1, 4 ), 'line' ) then break;
                while s <> '' do
                begin
                  line := Str2Int( s );
                  Parse( s, ' '#9 ); s := Trim( s );
                  seg := Str2Int( s );
                  Parse( s, ':' ); s := Trim( s );
                  addr := Hex2Int( s );
                  Parse( s, ' '#9 ); s := Trim( s );
                  if (seg = 1) and (line-1 < Src.Lines.Count) then
                  begin
                    brkline := Src.Lines.Objects[ line-1 ];
                    if Integer( brkline ) >= 0 then
                    begin
                      Src.BrkPts.Objects[ brkline and $FFFFFF ] :=
                        addr + CodeSegmentBase;
                    end
                      else
                    begin
                      j := Src.BrkPts.AddObject(
                        Int2Str( line ) + ' 0:?', addr + CodeSegmentBase );
                      Src.Lines.Objects[ line-1 ] := DWORD( j ) or $C0000000;
                      {for line1 := line-1 downto 0 do
                      begin
                        s := Src.Lines.Items[ line1 ];
                        j := pos( '//--by PCompiler:line#', s );
                        line2 := -1;
                        if j > 0 then
                        begin
                          for j := Length( s ) downto 1 do
                          begin
                            if not(s[ j ] in ['0'..'9']) then
                            begin
                              line2 := Str2Int( CopyEnd( s, j+1 ) ) - 1;
                              break;
                            end;
                          end;
                        end;
                        if (line2 >= 0) and (line2 <= line) then
                        begin
                          s := Src.BrkPts.Items[ Src.Lines.Objects[ line-1 ] and $FFFFFF ];
                          parse( s, ' ' );
                          s := Int2Str( line-1 + line2-line1 ) + ' ' + s;
                          Src.BrkPts.Add( )
                          break;
                        end;
                      end;}
                    end;
                  end;
                end;
              end;
              for j := 0 to Src.Lines.Count-1 do
              begin
                s := Src.Lines.Items[ j ];
                m := pos( '//--by PCompiler:line#', s );
                if m > 0 then
                begin
                  s := CopyEnd( s, m );
                  Parse( s, '#' );
                  s := Trim( s );
                  line := Str2Int( s );
                  if Src.Lines.Objects[ line-1 ] and $Ff000000 = $C0000000 then
                  begin
                    addr := Src.BrkPts.Objects[ Src.Lines.Objects[ line-1 ] and $FFFFFF ];
                    for m := j+1 to Src.Lines.Count-1 do
                    begin
                      s := Trim( Src.Lines.Items[ m ] );
                      if StrEq( Copy( s, 1, 2 ), '{$' ) then
                        break;
                      if Integer( Src.Lines.Objects[ m ] and $FFFFFF ) >= 0 then
                      begin
                        if Src.BrkPts.Objects[ Src.Lines.Objects[ m ] and $FFFFFF ] = 0 then
                        begin
                          s := Src.BrkPts.Items[ Src.Lines.Objects[ m ] and $FFFFFF ];
                          Parse( s, ' '#9 ); s := Trim( s );
                          Parse( s, ':' ); s := Trim( s );
                          Src.BrkPts.Objects[ Src.Lines.Objects[ m ] and $FFFFFF ] := Addr +
                            Str2Int( s );
                        end;
                      end;
                    end;
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    FINALLY
      SL.Free;
    END;
  end;
end;

function TfmMain.CalcTextWidth(Canv: PCanvas; const s: String): Integer;
begin
  if TmpBmp1 = nil then
    TmpBmp1 := NewDIBBitmap( 1, 1, pf1bit );
  TmpBmp1.Canvas.Font.Assign( Canv.Font );
  Result := TmpBmp1.Canvas.TextWidth( s );
end;

procedure TfmMain.lvCodeLVStateChange(Sender: PControl; IdxFrom,
  IdxTo: Integer; OldState, NewState: Cardinal);
var s: String;
    brkline: Integer;
begin
  if (OldState and lvis_selected = 0) and
     (NewState and lvis_selected <> 0) then
  begin
    brkline := Src.Lines.Objects[ IdxFrom ];
    s := 'Line:' + Int2Str( IdxFrom ) +
      ' brkline:' + Int2Str( brkline );
    if brkline >= 0 then
      s := s + ' brkaddr:' + Int2Hex( Src.BrkPts.Objects[ brkline ], 4 );
    pnStatus.Caption := s;
  end;
end;

procedure TfmMain.FindCurUnit;
var i: Integer;
    Src1: PSource;
begin
  for i := 0 to SrcList.Count-1 do
  begin
    Src1 := Pointer( SrcList.Objects[ i ] );
    if Src1 <> nil then
    if Src1.HasBrkAddr( DWORD( InstrPtr ) ) then
    begin
      cbUnit.CurIndex := i;
      cbUnitChange( nil );
      Exit;
    end;
  end;
end;

procedure TfmMain.KOLForm1Close(Sender: PObj; var Accept: Boolean);
begin
  Halt;
end;

initialization

finalization

end.



