unit Source;

interface

uses Windows, KOL;

type
  PSource = ^TSource;
  TSource = object( TObj )
    BrkPts: PStrListEx;
    Lines: PStrListEx;
    Path: String;
    ProcList: PStrListEx;
    procedure Init; virtual;
    destructor Destroy; virtual;
    procedure Load;
    function HasBrkAddr( addr: DWORD ): Boolean;
  end;

implementation

{ TSource }

destructor TSource.Destroy;
begin
  Path := '';
  Lines.Free;
  BrkPts.Free;
  ProcList.Free;
  inherited;
end;

function TSource.HasBrkAddr(addr: DWORD): Boolean;
var i: Integer;
    A: DWORD;
    yes1, yes2: Boolean;
begin
  Result := FALSE;
  if BrkPts = nil then Exit;
  Result := TRUE;
  yes1 := FALSE;
  yes2 := FALSE;
  for i := 0 to BrkPts.Count-1 do
  begin
    A := BrkPts.Objects[ i ] and $FFFFFF;
    if A = 0 then continue;
    if A = addr then Exit;
    if A < addr then yes1 := TRUE;
    if A > addr then yes2 := TRUE;
    if yes1 and yes2 then Exit;
  end;
  Result := FALSE;
end;

procedure TSource.Init;
begin
  BrkPts := NewStrListEx;
  Lines := NewStrListEx;
  ProcList := NewStrListEx;
end;

procedure TSource.Load;
var j, k: Integer;
    s: String;
begin
  Lines.LoadFromFile( Path );
  BrkPts.LoadFromFile( Path + '.debug' );
  for j := 0 to Lines.Count-1 do
  begin
    Lines.Objects[ j ] := DWORD( -1 );
    s := Lines.Items[ j ];
    if (s = '{$IFDEF Psource}') and (j > 0) then
    begin
      s := Lines.Items[ j-1 ];
      Parse( s, ' ' );
      s := Trim( s );
      s := Parse( s, '( '#9':;' );
      ProcList.AddObject( s, j+1 );
    end;
  end;
  for j := 0 to BrkPts.Count-1 do
  begin
    s := BrkPts.Items[ j ];
    if (pos( '+', s ) <= 0) and (pos( '*', s ) <= 0) then
    begin
      k := Str2Int( s );
      Lines.Objects[ k-1 ] := j;
      parse( s, '|' );
      k := Str2Int( s );
      Lines.Objects[ k-1 ] := j;
    end;
  end;
end;

end.
